\begin{tikzpicture}[%
uml box/.append style={lightgreenshading, font=\footnotesize},
uml role/.append style={font=\scriptsize},
]
\small

%% Objekte
\node[uml box, text width=5em] (user) {\uline{:User}};
\node[uml box, text width=5em] (webui) [right=1em of user] {\uline{:WebUI}};
\node[uml box] (mediamgmt) [right=1em of webui] {\uline{:MediaManagement}};
\node[uml box] (usermgmt) [right=1em of mediamgmt] {\uline{:UserManagement}};

% Lifelines
\foreach \x in {user,webui,mediamgmt,usermgmt} \draw[gray, dash pattern=on 1.5em off .4em] (\x.south) -- ++ (0,-21em);

\visible<2->{
\node[uml lifeline, minimum height=17em] (usermainline) at ([yshift=-3em]user.south) {};
}

%% not registered
\begin{scope}[uml lifeline/.append style={minimum height=2em}]
\visible<3->{
\node[uml lifeline] (userline1) at ([yshift=-.7em]usermainline.north east) {};

\node[uml lifeline] (webuiline1) at (userline1.north-|webui.south) {};
\node[uml lifeline] (usermgmtline1) at (webuiline1.north-|usermgmt.south) {};

\draw[-latex] (userline1.north east) -- node[uml role, above] {register()} (webuiline1.north west);
\draw[-latex] (webuiline1.north east) -- node[uml role, near start, above] {register()} (usermgmtline1.north west);

\draw[-latex, dashed] (usermgmtline1.south west) -- node[uml role, near end, above] {userID} (webuiline1.south east);
\draw[-latex, dashed] (webuiline1.south west) -- node[uml role, above] {success} (userline1.south east);
}

\visible<4->{
% Kasten
\draw[thick, gray] ([yshift=-.7em]user.south west) rectangle ([yshift=-.5em]usermgmt.east|-usermgmtline1.south);
\begin{pgfonlayer}{l1}
\visible<4->{
\node[anchor=north west, font=\footnotesize] (registerlabel) at ([yshift=-.7em]user.south west) {\textbf{opt} [not registered]};
}
\end{pgfonlayer}
\draw[thick, lightgreyshading] (registerlabel.south west) -- (registerlabel.south east) -- ++ (.7em,.7em) -- ([xshift=.7em]registerlabel.north east) -- (registerlabel.north west) -- cycle;
}

%% login
\visible<5->{
\node[uml lifeline] (userline2) at ([yshift=-2.5em]userline1.south) {};
\node[uml lifeline] (webuiline2) at (userline2.north -| webui.south) {};
\node[uml lifeline] (usermgmtline2) at (userline2.north -| usermgmt.south) {};

\draw[-latex] (userline2.north east) -- node[uml role, above] {login()} (webuiline2.north west);
\draw[-latex] (webuiline2.north east) -- node[uml role, near start, above] {login()} (usermgmtline2.north west);

\draw[-latex, dashed] (usermgmtline2.south west) -- node[uml role, near end, above] {loginStatus} (webuiline2.south east);
\draw[-latex, dashed] (webuiline2.south west) -- node[uml role, above] {sessionID} (userline2.south east);
}

%% get files
\visible<6->{
\node[uml lifeline] (userline3) at ([yshift=-2em]userline2.south) {};
\node[uml lifeline] (webuiline3) at (userline3.north -| webui.south) {};
\node[uml lifeline] (mediamgmtline1) at (userline3.north -| mediamgmt.south) {};

\draw[-latex] (userline3.north east) -- node[uml role, above] {getFilesList()} (webuiline3.north west);
\draw[-latex] (webuiline3.north east) -- node[uml role, above] {getFilesList()} (mediamgmtline1.north west);

\draw[-latex, dashed] (mediamgmtline1.south west) -- node[uml role, above] {fileList} (webuiline3.south east);
\draw[-latex, dashed] (webuiline3.south west) -- node[uml role, above] {fileList} (userline3.south east);
}


%% download
\visible<7->{
\node[uml lifeline] (userline4) at ([yshift=-3em]userline3.south) {};
\node[uml lifeline] (webuiline4) at (userline4.north -| webui.south) {};
\node[uml lifeline] (mediamgmtline2) at (userline4.north -| mediamgmt.south) {};

\draw[-latex] (userline4.north east) -- node[uml role, above] {download()} (webuiline4.north west);
\draw[-latex] (webuiline4.north east) -- node[uml role, above] {download()} (mediamgmtline2.north west);

\draw[-latex, dashed] (mediamgmtline2.south west) -- node[uml role, above] {mediaFile} (webuiline4.south east);
\draw[-latex, dashed] (webuiline4.south west) -- node[uml role, above] {mediaFile} (userline4.south east);
}

% Kasten
\visible<8->{
\draw[thick, gray] ([yshift=2em]user.west|-userline4.north) rectangle ([yshift=-1em]usermgmt.east|-mediamgmtline2.south);
\begin{pgfonlayer}{l1}
\visible<8->{
\node[anchor=north west, font=\footnotesize] (downloadlabel) at ([yshift=2em]user.west|-userline4.north) {\textbf{loop}};
}
\end{pgfonlayer}
\draw[thick, lightgreyshading] (downloadlabel.south west) -- (downloadlabel.south east) -- ++ (.7em,.7em) -- ([xshift=.7em]downloadlabel.north east) -- (downloadlabel.north west) -- cycle;
}
\end{scope}

\end{tikzpicture}